package ch.kousz.adrian.util;

public class ArrayGenerator
implements Iterable<int[]>
{
	private final int[] start;
	private final int max;

	public ArrayGenerator(int max)
	{
		this(max, new int[0]);
	}

	public ArrayGenerator(int max, int[] start)
	{
		this.max = max;
		this.start = start.clone();
	}

	@Override
	public java.util.Iterator<int[]> iterator()
	{
		return new ArrayGenerator.Iterator(this);
	}

	private static class Iterator
	implements java.util.Iterator<int[]>
	{
		private final int max;
		private int[] next;

		public Iterator(ArrayGenerator gen)
		{
			this.next = gen.start;
			this.max = gen.max;
		}

		@Override
		public boolean hasNext()
		{
			return true;
		}

		@Override
		public int[] next()
		{
			int[] result = next.clone();

			int i = 0;
			while (true) {
				if (i == next.length) {
					next = new int[i + 1];
					break;
				}
				next[i]++;
				if (next[i] < max) break;
				next[i] = 0;
				i++;
			}

			return result;
		}

		@Override
		public void remove()
		{
			throw new UnsupportedOperationException();
		}
	}
}
