package ch.kousz.adrian.util;

public class StringGenerator
implements Iterable<String>
{
	private final String charset;
	private final int startLength;

	public StringGenerator(String charset)
	{
		this(charset, 0);
	}

	public StringGenerator(String charset, int startLength)
	{
		this.charset = charset;
		this.startLength = startLength;
	}

	@Override
	public java.util.Iterator<String> iterator()
	{
		return new StringGenerator.Iterator(this);
	}

	private static class Iterator
	implements java.util.Iterator<String>
	{
		private final java.util.Iterator<int[]> arrayGenerator;
		private final char[] charset;

		public Iterator(StringGenerator gen)
		{
			this.charset = gen.charset.toCharArray();
			int max = this.charset.length;
			int[] start = new int[gen.startLength];
			this.arrayGenerator = new ArrayGenerator(max, start).iterator();
		}

		@Override
		public boolean hasNext()
		{
			return true;
		}

		@Override
		public String next()
		{
			int[] indices = arrayGenerator.next();
			char[] result = new char[indices.length];

			for (int i = 0; i < indices.length; i++) {
				result[i] = charset[indices[i]];
			}

			return String.valueOf(result);
		}

		@Override
		public void remove()
		{
			throw new UnsupportedOperationException();
		}
	}
}
